Add synthesize_dwarf.sh

Update documentation and Makefile accordingly.
This commit is contained in:
Théophile Bastian 2019-03-18 14:27:24 +01:00
parent 8fa2bc5952
commit 693a48f070
4 changed files with 108 additions and 3 deletions

2
.gitignore vendored
View File

@ -21,3 +21,5 @@ setup.data
setup.log
*.plugin
ml_dwarf_write.bin
tmp.marshal

View File

@ -3,7 +3,12 @@ BAPBUNDLE=bapbundle
ROOT_MODULE=dwarfsynth
all: install
all: install ml_dwarf_write.bin
.PHONY: ml_dwarf_write.bin
ml_dwarf_write.bin:
$(MAKE) -C DwarfSynth/c_bindings
ln -fs DwarfSynth/c_bindings/ml_dwarf_write.bin .
.PHONY: $(ROOT_MODULE).plugin
$(ROOT_MODULE).plugin:

View File

@ -11,9 +11,27 @@ examine its assembly code and, based solely on that, generate the corresponding
This tool relies on [BAP](https://github.com/BinaryAnalysisPlatform/bap), which
is available through OPAM.
## Running
## Compiling
First, run `make` to compile and install the BAP plugin.
Simply run `make` to compile all the necessary tools, including compiling and
installing the BAP plugin `dwarfsynth`.
## Running with a wrapper script
To generate an `.eh_frame` section for some binary `foo.bin` and write the
output as `foo.eh.bin`, you can run
```
./synthesize_dwarf foo.bin foo.eh.bin
```
You can also omit the second parameter to simply overwrite `foo.bin`.
## Running by hand
If you want, for some reason, to run by hand the multiple components, you can
follow this procedure (by using more appropriate file names, and, possibly, a
temporary directory -- see `mktemp -d`).
### Running the BAP plugin

80
synthesize_dwarf.sh Executable file
View File

@ -0,0 +1,80 @@
#!/bin/bash
###############################################################################
USAGE="$0 <binary_input_file> [<binary_output_file>]"
HELP_TEXT="synthesize_dwarf.sh
Script that sticks all the parts of dwarf-synthesis together.
Usage: $USAGE
The provided <binary_input_file> is expected **NOT** to have any .eh_frame
section.
If <binary_output_file> is provided, a binary file equivalent to
<binary_input_file> that contains an .eh_frame ELF section will be written as
<binary_output_file>.
If not, the input file will be overwriten with such a file."
###############################################################################
function find_ml_dwarf_write {
out=$(which "ml_dwarf_write.bin" 2>/dev/null)
if [ -n "$out" ] ; then
echo $out
return 0
fi
for location in . "$(dirname $0)" ; do
out="$location/ml_dwarf_write.bin"
if [ -x "$out" ] ; then
echo $out
return 0
fi
done
return 1
}
function bap_synth {
bap "$INPUT_FILE" -p dwarfsynth --dwarfsynth-output "$TMP_DIR/marshal" \
> /dev/null
return $?
}
function dwarf_write_synth {
$ML_DWARF_WRITE "$TMP_DIR/marshal" "$INPUT_FILE" "$TMP_DIR/eh_frame" \
> /dev/null
return $?
}
function dwarf_plug {
objcopy \
--add-section .eh_frame="$TMP_DIR/eh_frame" \
"$INPUT_FILE" "$OUTPUT_FILE"
return $?
}
if [ "$#" -lt "1" ] ; then
>&2 echo -e "Missing argument.\n\n$HELP_TEXT"
exit 1
fi
ML_DWARF_WRITE=$(find_ml_dwarf_write)
if [ "$?" -ne "0" ] ; then
>&2 echo -e "Cannot find ml_dwarf_write"
exit 1
fi
INPUT_FILE="$1"
OUTPUT_FILE="$2"
if ! [ -f "$INPUT_FILE" ] ; then
>&2 echo -e "$INPUT_FILE: no such file.\n\n$HELP_TEXT"
fi
TMP_DIR="$(mktemp -d)"
bap_synth \
&& dwarf_write_synth \
&& dwarf_plug
rm -rf "$TMP_DIR"